SystemOrganization addCategory: #Prolog!
SystemOrganization addCategory: #'Prolog-Predicate'!

!ByteSymbol methodsFor: '*Prolog' stamp: 'HwaJong 10/22/2012 17:12'!
representsPrologVariable
^self first isUppercase! !

!Object methodsFor: '*Prolog' stamp: 'HwaJong 10/22/2012 17:01'!
isPrologVariable
^false! !

!Object methodsFor: '*Prolog' stamp: 'HwaJong 10/22/2012 17:13'!
representsPrologVariable
^false! !

Object subclass: #PrologKnowledgeBase
	instanceVariableNames: 'entries flatGrandDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:27'!
entryAtPredicateName: aSymbol 
	^entries at: aSymbol ifAbsentPut: [OrderedCollection new] ! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 17:14'!
fact: aSymbol data: anArray 
	|o f|
	o := self entryAtPredicateName: aSymbol.
	f := Fact factName: aSymbol data: anArray.
	o addLast: f.
	flatGrandDomain addAll: f data.! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 13:20'!
flatEntries
	^entries values concatenateAll ! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 14:08'!
flatGrandDomain
^flatGrandDomain! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 14:06'!
initialize
super initialize.
entries := Dictionary new.
flatGrandDomain := Set new.! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 13:37'!
predicateNames
^entries keys! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:28'!
query: aSymbol data: anArray 
	(entries includesKey: aSymbol) ifFalse: [^false].
	(entries at: aSymbol) detect: [:each| each isTrueWithName: aSymbol data: anArray ] ifNone: [^false].
	^true! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 17:11'!
queryWhat: aSymbol data: anArray 
|q3 v|
v := PrologVariable new.
q3 := QueryWhat knowledgeBase: self predicateName: aSymbol data: (anArray collect: [:each| each representsPrologVariable ifTrue: [v] ifFalse: [each]]).
^q3 value.! !

!PrologKnowledgeBase methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:28'!
rule: aSymbol definition: aBlockClosure 
(self entryAtPredicateName: aSymbol) addLast: (Rule knowledgeBase: self blockClosure: aBlockClosure)! !

Object subclass: #PrologPredicate
	instanceVariableNames: 'predicateName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Predicate'!

PrologPredicate subclass: #Fact
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Predicate'!

!Fact classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:30'!
factName: aSymbol data: anArray 
^self new
	factName: aSymbol;
	data: anArray! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:29'!
accumulateSearchQueryIfCanBeTrueWith: anArray 
1 to: anArray size do:  [:index | 
	((anArray at: index) canBeTrueWith: (data at: index))
		ifFalse: [^self].
	].

1 to: anArray size do:  [:index |
	(anArray at: index) accumulateSearchQuery: (data at: index) ].! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 13:23'!
accumulateSearchQueryIfCanBeTrueWithMultiSearchQuery: aMultiSearchQuery 
	aMultiSearchQuery predicateName = self predicateName ifFalse: [^false].
	(1 to: data size) allSatisfy: [:index| (aMultiSearchQuery data at: index) canBeTrueWith: (data at: index) ] ! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:11'!
data

	^ data! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 21:46'!
data: anArray 
data := anArray! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:29'!
factName: aSymbol 
predicateName := aSymbol ! !

!Fact methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:29'!
isTrueWithName: aSymbol data: anArray 
	predicateName = aSymbol ifFalse: [^false].
	data = anArray ifFalse: [^false].
	^true   ! !

!PrologPredicate methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 13:21'!
predicateName
	^ predicateName! !

PrologPredicate subclass: #Rule
	instanceVariableNames: 'blockClosure knowledgeBase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Predicate'!

!Rule classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:39'!
blockClosure: aBlockClosure 
^self new
	blockClosure: aBlockClosure! !

!Rule classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 12:43'!
knowledgeBase: aPrologKnowledgeBase blockClosure: aBlockClosure 
^self new
	blockClosure: aBlockClosure;
	knowledgeBase: aPrologKnowledgeBase! !

!Rule methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:45'!
accumulateSearchQueryIfCanBeTrueWith: anArray 
	self shouldBeImplemented.! !

!Rule methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/21/2012 22:39'!
blockClosure: aBlockClosure 
blockClosure := aBlockClosure ! !

!Rule methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 15:29'!
isTrueWithName: aSymbol data: anArray 
^blockClosure valueWithArguments: anArray. ! !

!Rule methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 12:42'!
knowledgeBase
	^ knowledgeBase! !

!Rule methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 12:42'!
knowledgeBase: aPrologKnowledgeBase
	knowledgeBase := aPrologKnowledgeBase
! !

Object subclass: #PrologVariable
	instanceVariableNames: 'collectedCases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologVariable methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 17:01'!
isPrologVariable
^true! !

Object subclass: #QueryWhat
	instanceVariableNames: 'knowledgeBase queryFact collectedCases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!QueryWhat classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 16:38'!
knowledgeBase: aPrologKnowledgeBase predicateName: aSymbol data: anArray 

^self new
	knowledgeBase: aPrologKnowledgeBase;
	queryFact: (Fact factName: aSymbol data: anArray)! !

!QueryWhat methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 16:48'!
collectResultFromArray: anArray 
self collectedCases addLast: (self queryIndicies collect: [:index| anArray at: index])! !

!QueryWhat methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 16:45'!
collectedCases
collectedCases ifNil: [collectedCases := OrderedCollection new].
^collectedCases ! !

!QueryWhat methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 16:38'!
knowledgeBase: aPrologKnowledgeBase 
knowledgeBase := aPrologKnowledgeBase ! !

!QueryWhat methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 16:38'!
queryFact: aFact 
queryFact := aFact ! !

!QueryWhat methodsFor: 'accessing' stamp: 'HwaJong 10/22/2012 17:01'!
queryIndicies
^(1 to: queryFact data size) select: [:index| (queryFact data at: index) isPrologVariable ].! !

!QueryWhat methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 17:01'!
run

| md anArray aSymbol |
anArray := queryFact data.
aSymbol := queryFact predicateName.
md := TTTMultiDimensionalDo new
	domains: ((1 to: anArray size) collect: [:index| (anArray at: index) isPrologVariable ifTrue: [knowledgeBase flatGrandDomain asArray] ifFalse: [{anArray at: index}]] );
	block: [:array| (knowledgeBase query: aSymbol data: array)
			ifTrue: [ self collectResultFromArray: array ].
		];
	run.! !

!QueryWhat methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/22/2012 16:52'!
value
self run.
^self collectedCases! !
